// ----------------------------------------------------------------------------
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
// ----------------------------------------------------------------------------

// Reset report list
AppOwnsData.resetReportList = function () {
    const len = AppOwnsData.reportSelect.get(0).options.length;
    for (let i = 1; i < len; i++) {
        AppOwnsData.reportSelect.get(0).remove(i);
    }

    // Set default option as selected
    AppOwnsData.reportSelect.get(0).options[0].selected = true;
}

// Reset dashboard list
AppOwnsData.resetDashboardList = function () {
    const len = AppOwnsData.dashboardSelect.get(0).options.length;
    for (let i = 1; i < len; i++) {
        AppOwnsData.dashboardSelect.get(0).remove(i);
    }

    // Set default option as selected
    AppOwnsData.dashboardSelect.get(0).options[0].selected = true;
}

// Reset tile list
AppOwnsData.resetTileList = function () {
    const len = AppOwnsData.tileSelect.get(0).options.length;
    for (let i = 1; i < len; i++) {
        AppOwnsData.tileSelect.get(0).remove(i);
    }

    // Set default option as selected
    AppOwnsData.tileSelect.get(0).options[0].selected = true;
}

// Fetch workspaces list from server
AppOwnsData.getWorkspaces = function (getSelectParams) {
    $.ajax({
        type: "GET",
        url: "/embedinfo/getworkspace",
        data: getSelectParams,
        contentType: "application/json; charset=utf-8",
        success: function (data) {

            // Populate select list
            for (let i = 0; i < data.length; i++) {
                AppOwnsData.workspaceSelect.append(
                    $("<option />")
                        .text(data[i].name)
                        .val(data[i].id)
                );
            }

            if (data.length >= 1) {
                // Enable workspace select list
                AppOwnsData.workspaceSelect.removeAttr("disabled");
            }
        },
        error: function (err) {
            AppOwnsData.showError(err);
        }
    });
}

// Fetch reports list from server
AppOwnsData.getReports = function (getSelectParams) {
    $.ajax({
        type: "GET",
        url: "/embedinfo/getreport",
        data: getSelectParams,
        contentType: "application/json; charset=utf-8",
        success: function (data) {

            // Populate select list
            for (let i = 0; i < data.length; i++) {
                AppOwnsData.reportSelect.append(
                    $("<option />")
                        .text(data[i].name)
                        .val(data[i].id)
                );
            }

            if (data.length >= 1) {

                // Enable report select list
                AppOwnsData.reportSelect.removeAttr("disabled");
            }
        },
        error: function (err) {
            AppOwnsData.showError(err);
        }
    });
}

// Fetch dashboards list from server
AppOwnsData.getDashboards = function (getSelectParams) {
    $.ajax({
        type: "GET",
        url: "/embedinfo/getdashboard",
        data: getSelectParams,
        contentType: "application/json; charset=utf-8",
        success: function (data) {

            // Populate select list
            for (let i = 0; i < data.length; i++) {
                AppOwnsData.dashboardSelect.append(
                    $("<option />")
                        .text(data[i].displayName)
                        .val(data[i].id)
                );
            }

            if (data.length >= 1) {

                // Enable dashboard select list
                AppOwnsData.dashboardSelect.removeAttr("disabled");
            }
        },
        error: function (err) {
            AppOwnsData.showError(err);
        }
    });
}

// Fetch tiles list from server
AppOwnsData.getTiles = function (getSelectParams) {
    $.ajax({
        type: "GET",
        url: "/embedinfo/gettile",
        data: getSelectParams,
        contentType: "application/json; charset=utf-8",
        success: function (data) {

            // Populate select list
            for (let i = 0; i < data.length; i++) {
                AppOwnsData.tileSelect.append(
                    $("<option />")
                        .text(data[i].title)
                        .val(data[i].id)
                );
            }

            if (data.length >= 1) {

                // Enable tile select list
                AppOwnsData.tileSelect.removeAttr("disabled");
            }
        },
        error: function (err) {
            AppOwnsData.showError(err);
        }
    });
}